/*********************************************************************
*  IVXR[v
*  YHY024006A QVGAJ[OtBbNLCD
*@240x320hbg@16rbgJ[ u\
*@vWFNgF Scope
*********************************************************************/
#include "p33FJ64GP802.h"
#include "colorlcd_libdsPICVH.h"
#include <math.h>
#include <stdlib.h>

/*** RtBM[Vݒ  80MHz ***/
_FOSCSEL(FNOSC_PRIPLL & IESO_OFF);		// Prim OSC
_FOSC(FCKSM_CSDCMD & IOL1WAY_OFF & OSCIOFNC_OFF & POSCMD_XT);
_FWDT(FWDTEN_OFF);
_FPOR(ALTI2C_OFF & FPWRT_PWR32);
_FICD(JTAGEN_OFF & ICS_PGD1);

/** AiOvf[^i[pobt@ **/
int Buffer1[512];					// CH1p
int Buffer2[512];					// CH2p
unsigned int BufferA[256] __attribute__((space(dma)));
unsigned int BufferB[256] __attribute__((space(dma)));
int Period, Count, Trig, Chanel, Chatta, Sync;
char MsgScrn[] = "X=xxx Y=xxx";	// fobOpW\
/* ^b`{^Wf[^ */
int Button[7][2] = {{780,170},{770,280},{770,400},{760,510},{760,620},{730,120},{720,680}};  
char MsgUp[] = {0xEB, 0};
char MsgDown[] = {0xED, 0};
/** ֐vg^CsO  **/
void SetupOSC(int _period);
void SetupScreen(void);
int Getscreen(unsigned int chn);
void Process(int sw);
void Oscillo(void);
void AxisDraw(int _period);
int CheckBtn(int x, int y);
void itostring(char digit, unsigned int data, char *buffer);

/********************************************************************************/
/************************************************
* C֐
************************************************/
int main(void){
	/* Setup System */
	OSCCON = 0x00300;				// PRIPLLw
	CLKDIV = 0x0100;				// NbN̕1:2ɐݒ
	PLLFBD = 0x0026;				// 40{@8MHz2~402 = 80MHz
	/* Setup PORT In/Out */
	TRISA = 0xFFEF;				// RA4 output
	TRISB = 0x000F;				// RB0-3 is input
	/* t\̏ */
	lcd_Init();
	lcd_Clear(BLACK);
	/* ^C}1ݒ 50msec ^b`XN[p */
	T1CON = 0x0030;
	PR1 = 7800;					// 50msec
	IFS0bits.T1IF = 0;			// 荞݃tONA
	IEC0bits.T1IE = 1;			// 荞݋
	/* ^C}45ݒ@1sec IVp  */
	T4CON = 0x0008;				// 32bit mode
	PR4 = 0;
	PR5 = 600;					// 1sec timer
	IFS1bits.T5IF = 0;			// 荞݃tONA
	IEC1bits.T5IE = 1;			// 荞݋
	/* ^C}Rݒ@IVp */
	T3CON = 0;
	/*** ϐ ***/
	Chanel = 0;
	Trig = 116;
	Period = 0;
	Count = 0;
	Chatta = 0;
	Sync = 0;
	SetupScreen();				// ADCݒύX
	/* ^C}P,45Jn */
	T1CONbits.TON = 1;
	T4CONbits.TON = 1;
	/****** C@[v@****/	
	while(1){

	}
}
/*******************************************************************************/

/******************************************
*  ^C}1荞ݏ(50msec)
*  ^b`XN[@AiO 
*******************************************/
void __attribute__((interrupt, auto_psv)) _T1Interrupt(void)
{
	static int i, Xset, Yset, Xold, Yold;

	IFS0bits.T1IF = 0;			// 荞݃tONA
	/* ^b`XN[pADCݒ */
	SetupScreen();
	// X+=B2(AN4) X-=B0 Y+=B3(AN5) Y-=B1
	/*** XW ****/
	TRISBbits.TRISB3 = 0;			// RB3 RB1 is output
	TRISBbits.TRISB1 = 0;
	LATBbits.LATB3 = 0;			// Set Voltage
	LATBbits.LATB1 = 1;
	TRISBbits.TRISB2 = 1;			// RB0,RB2 input
	TRISBbits.TRISB0 = 1;
	for(i=0; i<50; i++)			// [d҂ 11usec
		Nop();
	Xset = Getscreen(4);			// Wl擾
	/**** YẂ@****/
	TRISBbits.TRISB0 = 0;			// RB2,RB0 output
	TRISBbits.TRISB2 = 0;
	LATBbits.LATB0 = 1;			// Set Voltage
	LATBbits.LATB2 = 0;
	TRISBbits.TRISB1 = 1;			// RB3, RB1 is input
	TRISBbits.TRISB3 = 1;
	for(i=0; i<50; i++)			// [d҂ 11usec
		Nop();
	Yset = Getscreen(5);			// Wl擾
	/*** ^b`ĂȂƂ̉ ***/
	if((Xset > 40)&&(Yset > 60)){
		/*** mȃ^b`̌o@**/
		if((abs(Xset - Xold) < 15) && abs(Yset - Yold) < 15){
			Count++;
			if((Count >= 3)&&(Chatta==0)){
				Count = 0;
				Process(CheckBtn(Xset, Yset));
				if(Chatta)
					AxisDraw(Period);	// W\	
			}
		}
		else
			Count = 0;
		Xold = Xset;
		Yold = Yset;
	}
}
/********************************
*   W擾s֐
********************************/
int Getscreen(unsigned int chn)
{
	int i;

	AD1CON1bits.ADON = 0;
	AD1CHS0 = chn;				// Select Channel
	AD1CON1bits.ADON = 1;
	AD1CON1bits.SAMP = 1;
	for(i=0; i<50; i++)			// Wait Aquisition 11usec
		Nop();
	AD1CON1bits.SAMP = 0;			// A/D convert start
	while(!AD1CON1bits.DONE);		// wait conversion
	return(ADC1BUF0);				// return result
}
/****************************************
*  ^b`XN[pݒύX
****************************************/
void SetupScreen(void)
{
	/* ADC̐ݒ */
	AD1CON1bits.ADON = 0;
	AD1CON1 = 0x0000;				// ADItA蓮
	AD1CON2 = 0;					// AVdd, AVss, SCANȂ,MUXÂ
	AD1CON3 = 0x0304;				// 3Tad , Tad = 5*Tcy
	AD1CON4 = 0;					// 1word DMAobt@
	AD1CHS123 = 0;				// TvȂ
 	AD1CHS0 = 0x0000;				// `lI
	AD1PCFGL = 0xFFC0;			// AN0-5 is analog
	AD1CSSL = 0;					// XLȂ
	AD1CON1bits.ADON = 1;			// ADL

}
/****************************************
* ^b`{^菈
****************************************/
int CheckBtn(int x, int y)
{
	int i, btn;
	/*** ^b`Wʒu\ifobOp)@****/
	itostring(3, x, MsgScrn+2);
	itostring(3, y, MsgScrn+8);
	lcd_Str(5, 16, MsgScrn, RED, WHITE);
	/** {^`FbN **/
	btn = -1;
	for(	i=0; i<7; i++){
		if((x > Button[i][0]-20)&&(x <	Button[i][0]+20)){
			if((y > Button[i][1]-30)&&(y < Button[i][1]+30))
				btn = i;
		}
	}
	return(btn);
}
/********************************************
*  XCb`Ƃ̏
*   SW1:`l\I 0:1+2 1:1 2:2
*   SW2:gKxAbv
*   SW3:gKx_E
*   SW4:ύX
*   SW5:
*********************************************/
void Process(int sw)
{
	switch(sw){
		case 0:					// `l\XV
			Chanel++;
			if(Chanel == 3)
				Chanel = 0;
			Chatta = 1;
			break;
		case 1:	

			break;
		case 2:					// ԎύX
			Period--;
			if(Period < 0)
				Period = 4;
			Chatta = 1;
			break;
		case 3:					// ԎύX
			Period++;
			if(Period > 4)
				Period = 0;
			Chatta = 1;
			break;
		case 4:					// gKL
			Sync++;
			if(Sync > 2)
				Sync = 0;
			Chatta = 1;
			break;
		case 5:					// gK_E
			if(Trig > 5)
				Trig -=5;
			lcd_Line(310, Trig, 319, Trig, YELLOW);
			break;
		case 6:					// gKAbv
			if(Trig < 234)
				Trig +=5;
			lcd_Line(310, Trig, 319, Trig, YELLOW);
			break;
		default:
			break;
	}
}

/***************************************
* ASCIIɕϊ
****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;					// Ō̐ʒu
	for(i=digit; i>0; i--) {			// ϊ͉ʂʂ
		buffer--;					// |C^[P
		*buffer = (data % 10) + '0';	// ASCII
		data = data / 10;				// ̌
	}
}

/*******************************************************************************/
/***************************************
* ^C}45荞ݏ
*  IVXR[v
***************************************/
void __attribute__((interrupt, auto_psv)) _T5Interrupt(void)
{
	static int i, j;

	IFS1bits.T5IF = 0;				// 荞݃tONA
	/* IVpݒAADCDMA */
	SetupOSC(0);
	/* Ώۃf[^DMÁ@512Tv */
	for(j=0; j<4; j++){
		while(!IFS0bits.DMA0IF);
		IFS0bits.DMA0IF = 0;		// 荞݃tONA
		if(DMACS1bits.PPST0){		// s|obt@ABH
			for(i=0; i<128; i++){
				Buffer1[j*128+i] = BufferB[i]*5/22;
				Buffer2[j*128+i] = BufferB[128+i]*5/22;
			}
		}
		else{
			for(i=0; i<128; i++){
				Buffer1[j*128+i] = BufferA[i]*5/22;
				Buffer2[j*128+i] = BufferA[128+i]*5/22;
			}
		}
	}
	T3CONbits.TON = 0;				// ADC~
	/* ̓f[^̃Ot\ */		
	Oscillo();						// \
}

/*******************************************
*  IVf[^͗p֐
*  A/DTvADMA128񎩓ۑ
*******************************************/
void SetupOSC(int _period)
{
	/* ADC̐ݒ  */
	AD1CON1bits.ADON = 0;
	AD1CON1  = 0x004C;				// AD OffA10bit, A^C}3gKADMA Gather
	AD1CON2  = 0x0100;				// AVdd, AVss,CH0+CH1Scan,DMA1
	AD1CON3  = 0x0203;				// 2TadTvATad = 25nsec*4=100nsec>76ns
	AD1CON4 	= 0x0007;				// `l128DMAobt@ 
 	AD1CHS123= 0x0000;				// CH1AN0I
	AD1CHS0  = 0x0001;				// CH0AN1I
	AD1CSSL  = 0x0000;				// XLȂ
	AD1PCFGL = 0xFFC0;				// AN0-5AiO 
	AD1CON1bits.ADON = 1;				// ADX^[g
	/** DMA Peipheral Addressing Mode, continuous Ping-Pon **/
	DMA0CON	= 0x0022;
	DMA0PAD	= (int)&ADC1BUF0;
	DMA0CNT	= 255;					// 128 samples
	DMA0REQ	= 13;					// ADC1BUF0
	DMA0STA	= __builtin_dmaoffset(BufferA);
	DMA0STB	= __builtin_dmaoffset(BufferB);
	IFS0bits.DMA0IF = 0;				
	DMA0CONbits.CHEN = 1;				// DMA Start

	T3CONbits.TON = 1;				// ADRo[^X^[g
}
	
/*****************************************************
*  IVXR[v\Aۑf[^\
*  gKoĂ̈ʒu320f[^\
*  gKvȂ΍ŏ320f[^\
*****************************************************/
void Oscillo(void){
	int i,x, Point;

	if(Sync == 0){
	/* gKȂAŏ\@*/
		AxisDraw(Period);						// W\
		for(i=1; i<=320; i++){
			if((Chanel == 0)||(Chanel == 1))
				lcd_Line(i, Buffer1[i-1], i, Buffer1[i], MAGENTA);
			if((Chanel == 0)||(Chanel == 2))
				lcd_Line(i, Buffer2[i-1], i, Buffer2[i], GREEN);		
		}
	}
	else{
		Point = -1;							// ŏ̃f[^
		/* gK`FbN  */
		if(Sync == 1){
			for(x=0; x<190; x++){
				if((Buffer1[x] < Trig) && (Buffer1[x+5] >= Trig)){
					Point = x;
					continue;
				}
			}
		}
		else{
			for(x=0; x<190; x++){
				if((Buffer2[x] < Trig) && (Buffer2[x+5] >= Trig)){
					Point = x;
					continue;
				}
			}
		}	
		/* gKAg`\  */
		if(Point != -1){
			AxisDraw(Period);					// W\
			for(i=1; i<=320; i++){
				if((Chanel == 0)||(Chanel == 1))
					lcd_Line(i, Buffer1[i+Point-1], i, Buffer1[i+Point], MAGENTA);
				if((Chanel == 0)||(Chanel == 2))
					lcd_Line(i, Buffer2[i+Point-1], i, Buffer2[i+Point], GREEN);
			}
		}
	}
	Chatta = 0;
}
/******************************************
*  OtW̕\
*******************************************/
void AxisDraw(int _period)
{
	int i;
	
	/* XAYW,⏕\ */
	lcd_Clear(BLACK);
	for(i=0; i<319; i+=50)
		lcd_Line(i, 0, i, 231, BROWN);	// Y axis
	for(i=0; i<239; i+=58)
		lcd_Line(0, i, 319, i, BROWN);	// X axis
	/* TvO̕\ 2`l */
	switch(_period){
		case 0:
			lcd_Str(13, 0, "0.2msec/dec", CYAN, BLACK);
			PR3 = 159;			// 25n*160=4.0usec
			break;
		case 1:
			lcd_Str(13, 0, "0.5msec/dec", CYAN, BLACK);
			PR3 = 399;			// 25n*400=10usec
			break;
		case 2:
			lcd_Str(13, 0, "1.0msec/dec", CYAN, BLACK);
			PR3 = 799;			// 25*800=20usec
			break;
		case 3:
			lcd_Str(13, 0, "2.0msec/dec", CYAN, BLACK);
			PR3 = 1599;			// 25*1600=40usec 
			break;
		case 4:
			lcd_Str(13, 0, "5.0msec/dec", CYAN, BLACK);
			PR3 =3999;			// 25*4000=100usec
			break;
		default:
			lcd_Str(13, 0, "1.0msec/dec", CYAN, BLACK);
			PR3 = 399;			// 10usec
			break;
	}
	/* gKʒu\ */
	lcd_Line(310, Trig, 319, Trig, YELLOW);
	switch(Sync){
		case 0:
			lcd_Str(0, 0, "Free", RED, WHITE);
			break;
		case 1:
			lcd_Str(0, 0, "CH1 ", BLACK, MAGENTA);
			break;
		case 2:
			lcd_Str(0, 0, "CH2 ", BLACK, GREEN);
		default: break;
	}
	lcd_Str(25, 0, MsgUp, BLACK, WHITE);
	lcd_Str(25, 16, MsgDown, BLACK, WHITE);		
}
